## org.jboss.util
Interface SchedulerMBean

All Superinterfaces:
  Service, ServiceMBean

All Known Implementing Classes:
  Scheduler

public interface SchedulerMBean
extends ServiceMBean

This interface defines the manageable interface for a Scheduler Service allowing the client to create a Schedulable instance which is then run by this service at given times or to use a MBean which is called by this service at given times.
Attention: You have two ways to specify the Schedulable. Either you specify a Schedulable Class which is created and used by the Scheduler or you specify a JMX MBean which the specified method is called. Note that the last method of `setSchedulableClass(java.lang.String)` or `setSchedulableMBean(java.lang.String)` defines which one is used. Therefore you should never mixed these two.

Author:
  Andreas Schaefer

Field Summary
`static java.lang.String` `OBJECT_NAME`

Fields inherited from interface org.jboss.util.ServiceMBean
`STARTED, STARTING, states, STOPPED, STOPPING`

Method Summary
`long` `getInitialRepetitions()`
`java.lang.String` `getInitialStartDate()`
`long` `getRemainingRepetitions()`
`java.lang.String` `getSchedulableArguments()`
`java.lang.String` `getSchedulableArgumentTypes()`
`java.lang.String` `getSchedulableClass()`
`java.lang.String` `getSchedulableMBean()`
`java.lang.String` `getSchedulableMBeanMethod()`
`long` `getSchedulePeriod()`
`boolean` `isActive()`
`boolean` `isRestartPending()`
`boolean` `isStartAtStartup()`
`boolean` `isStarted()`
`boolean` `isUsingMBean()`
`void` `restartSchedule()` Stops the server right now and starts it right now.
`void` `setInitialRepetitions(long pNumberOfCalls)` Sets the initial number of scheduled calls.
`void` `setInitialStartDate(java.lang.String pStartDate)` Sets the first scheduled call.
`void` `setSchedulableArguments(java.lang.String pArgumentList)` Sets the comma seperated list of arguments for the Schedulable class.
`void` `setSchedulableArgumentTypes(java.lang.String pTypeList)` Sets the comma seperated list of argument types for the Schedulable class.
`void` `setSchedulableClass(java.lang.String pSchedulableClass)` Sets the fully qualified Class name of the Schedulable Class being called by the Scheduler.
`void` `setSchedulableMBean(java.lang.String pSchedulableMBean)` Sets the fully qualified JMX MBean name of the Schedulable MBean to be called.
`void` `setSchedulableMBeanMethod(java.lang.String pSchedulableMBeanMethod)` Sets the method name to be called on the Schedulable MBean.
`void` `setSchedulePeriod(long pPeriod)` Sets the Schedule Period between two scheduled call.
`void` `setStartAtStartup(boolean pStartAtStartup)` Set the scheduler to start when MBean started or not.
`void` `startSchedule()` Starts the schedule if the schedule is stopped otherwise nothing will happen.
`void` `stopSchedule(boolean pDoItNow)` Stops the schedule because it is either not used anymore or to restart it with new values.

Methods inherited from interface org.jboss.util.ServiceMBean
`getName, getState, getStateString`

Methods inherited from interface org.jboss.util.Service
`destroy, init, start, stop`

Field Detail

### OBJECT_NAME

    public static final java.lang.String OBJECT_NAME

Method Detail

### startSchedule

    public void startSchedule()

  Starts the schedule if the schedule is stopped otherwise nothing will happen. The Schedule is immediately set to started even the first call is in the future.
  Throws:
    `java.security.InvalidParameterException` - If any of the necessary values are not set or invalid (especially for the Schedulable class attributes).

### stopSchedule

    public void stopSchedule(boolean pDoItNow)

  Stops the schedule because it is either not used anymore or to restart it with new values.
  Parameters:
    `pDoItNow` - If true the schedule will be stopped without waiting for the next scheduled call otherwise the next call will be performed before the schedule is stopped.

### restartSchedule

    public void restartSchedule()

  Stops the server right now and starts it right now.

### getSchedulableClass

    public java.lang.String getSchedulableClass()

  Returns:
    Full qualified Class name of the schedulable class called by the schedule or null if not set.

### setSchedulableClass

    public void setSchedulableClass(java.lang.String pSchedulableClass)
                             throws java.security.InvalidParameterException

  Sets the fully qualified Class name of the Schedulable Class being called by the Scheduler. Must be set before the Schedule is started. Please also set the `setSchedulableArguments(java.lang.String)` and `setSchedulableArgumentTypes(java.lang.String)`.
  Parameters:
    `pSchedulableClass` - Fully Qualified Schedulable Class.
  Throws:
    `java.security.InvalidParameterException` - If the given value is not a valid class or cannot be loaded by the Scheduler or is not of instance Schedulable.

### getSchedulableArguments

    public java.lang.String getSchedulableArguments()

  Returns:
    Comma seperated list of Constructor Arguments used to instantiate the Schedulable class instance. Right now only basic data types, String and Classes with a Constructor with a String as only argument are supported.

### setSchedulableArguments

    public void setSchedulableArguments(java.lang.String pArgumentList)

  Sets the comma seperated list of arguments for the Schedulable class. Note that this list must have as many elements as the Schedulable Argument Type list otherwise the start of the Scheduler will fail. Right now only basic data types, String and Classes with a Constructor with a String as only argument are supported.
  Parameters:
    `pArgumentList` - List of arguments used to create the Schedulable intance. If the list is null or empty then the no-args constructor is used.

### getSchedulableArgumentTypes

    public java.lang.String getSchedulableArgumentTypes()

  Returns:
    A comma seperated list of Argument Types which should match the list of arguments.

### setSchedulableArgumentTypes

    public void setSchedulableArgumentTypes(java.lang.String pTypeList)
                                     throws java.security.InvalidParameterException

  Sets the comma seperated list of argument types for the Schedulable class. This will be used to find the right constructor and to created the right instances to call the constructor with. This list must have as many elements as the Schedulable Arguments list otherwise the start of the Scheduler will fail. Right now only basic data types, String and Classes with a Constructor with a String as only argument are supported.
  Parameters:
    `pTypeList` - List of arguments used to create the Schedulable intance. If the list is null or empty then the no-args constructor is used.
  Throws:
    `java.security.InvalidParameterException` - If the given list contains a unknow datat type.

### getSchedulableMBean

    public java.lang.String getSchedulableMBean()

  Returns:
    Object Name if a Schedulalbe MBean is set

### setSchedulableMBean

    public void setSchedulableMBean(java.lang.String pSchedulableMBean)
                             throws java.security.InvalidParameterException

  Sets the fully qualified JMX MBean name of the Schedulable MBean to be called. Attention: if set the all values set by `setSchedulableClass(java.lang.String)`, `setSchedulableArguments(java.lang.String)` and `setSchedulableArgumentTypes(java.lang.String)` are cleared and not used anymore. Therefore only use either Schedulable Class or Schedulable MBean. If `setSchedulableMBeanMethod(java.lang.String)` is not set then the schedule method as in the `Schedulable.perform(java.util.Date, long)` will be called with the same arguments. Also note that the Object Name will not be checked if the MBean is available. If the MBean is not available it will not be called but the remaining repetitions will be decreased.
  Parameters:
    `pSchedulableMBean` - JMX MBean Object Name which should be called.
  Throws:
    `java.security.InvalidParameterException` - If the given value is an valid Object Name.

### getSchedulableMBeanMethod

    public java.lang.String getSchedulableMBeanMethod()

  Returns:
    Schedulable MBean Method description if set

### setSchedulableMBeanMethod

    public void setSchedulableMBeanMethod(java.lang.String pSchedulableMBeanMethod)
                                   throws java.security.InvalidParameterException

  Sets the method name to be called on the Schedulable MBean. It can optionally be followed by an opening bracket, list of attributes (see below) and a closing bracket. The list of attributes can contain:
  - NOTIFICATION which will be replaced by the timers notification instance (javax.management.Notification)
  - DATE which will be replaced by the date of the notification call (java.util.Date)
  - REPETITIONS which will be replaced by the number of remaining repetitions (long)
  - SCHEDULER_NAME which will be replaced by the Object Name of the Scheduler (javax.management.ObjectName)
  - any full qualified Class name which the Scheduler will be set a "null" value for it
  An example could be: "doSomething( NOTIFICATION, REPETITIONS, java.lang.String )" where the Scheduler will pass the timer's notification instance, the remaining repetitions as int and a null to the MBean's doSomething() method which must have the following signature: doSomething( javax.management.Notification, long, java.lang.String ).
  Parameters:
    `pSchedulableMBeanMethod` - Name of the method to be called optional followed by method arguments (see above).
  Throws:
    `java.security.InvalidParameterException` - If the given value is not of the right format

### isUsingMBean

    public boolean isUsingMBean()

  Returns:
    True if the Scheduler uses a Schedulable MBean, false if it uses a Schedulable class

### getSchedulePeriod

    public long getSchedulePeriod()

  Returns:
    Schedule Period between two scheduled calls in Milliseconds. It will always be bigger than 0 except it returns -1 then the schedule is stopped.

### setSchedulePeriod

    public void setSchedulePeriod(long pPeriod)

  Sets the Schedule Period between two scheduled call.
  Parameters:
    `pPeriod` - Time between to scheduled calls (after the initial call) in Milliseconds. This value must be bigger than 0.
  Throws:
    `java.security.InvalidParameterException` - If the given value is less or equal than 0

### getInitialStartDate

    public java.lang.String getInitialStartDate()

  Returns:
    Date (and time) of the first scheduled. For value see `setInitialStartDate()` method.

### setInitialStartDate

    public void setInitialStartDate(java.lang.String pStartDate)

  Sets the first scheduled call. If the date is in the past the scheduler tries to find the next available start date.
  Parameters:
    `pStartDate` - Date when the initial call is scheduled. It can be either:
    - NOW: date will be the current date (new Date()) plus 1 seconds
    - Date as String able to be parsed by SimpleDateFormat with default format
    - Milliseconds since 1/1/1970
    If the date is in the past the Scheduler will search a start date in the future with respect to the initial repe- titions and the period between calls. This means that when you restart the MBean (restarting JBoss etc.) it will start at the next scheduled time. When no start date is available in the future the Scheduler will not start.
    Example: if you start your Schedulable everyday at Noon and you restart your JBoss server then it will start at the next Noon (the same if started before Noon or the next day if start after Noon).

### getInitialRepetitions

    public long getInitialRepetitions()

  Returns:
    Number of scheduled calls initially. If -1 then there is not limit.

### setInitialRepetitions

    public void setInitialRepetitions(long pNumberOfCalls)

  Sets the initial number of scheduled calls.
  Parameters:
    `pNumberOfCalls` - Initial Number of scheduled calls. If -1 then the number is unlimted.
  Throws:
    `java.security.InvalidParameterException` - If the given value is less or equal than 0

### getRemainingRepetitions

    public long getRemainingRepetitions()

  Returns:
    Number of remaining repetitions. If -1 then there is no limit.

### isStarted

    public boolean isStarted()

  Returns:
    True if the schedule is up and running. If you want to start the schedule with another values by using {@ #startSchedule} you have to stop the schedule first with {@ #stopSchedule} and wait until this method returns false.

### isRestartPending

    public boolean isRestartPending()

  Returns:
    True if any attributes are changed but the Schedule is not restarted yet.

### isStartAtStartup

    public boolean isStartAtStartup()

  Returns:
    True if the Schedule when the Scheduler is started

### setStartAtStartup

    public void setStartAtStartup(boolean pStartAtStartup)

  Set the scheduler to start when MBean started or not. Note that this method only affects when the `startService()` gets called (normally at startup time.
  Parameters:
    `pStartAtStartup` - True if Schedule has to be started at startup time

### isActive

    public boolean isActive()

  Returns:
    True if this Scheduler is active and will send notifications in the future

Copyright © 2000 The JBoss Organization. All Rights Reserved.